/***************************************************************************
 *   Copyright (C) 2004 by Walter Roth                                     *
 *   walter@amd2600-roth                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GUILOGIN_H
#define GUILOGIN_H

#include "guiloginbase.h"
#include "hobit.h"
#include "guimain.h"
#include <qwidgetstack.h>

class GuiMain;


class GuiLogin: public GuiLoginBase
{

  Q_OBJECT


public:

  /**
  *constructor of GuiLogin
  *
  *@param parent a pointer on the main widgets widget stack
  *@param stack main QWidget Stack in the 'main frame'
  *@param name widgets title
  *@param hobit the hobit object, needed for hbci functions
  */
  GuiLogin(QWidget* parent, GuiMain * guimain, const char *name = 0, HoBIT* hobit = 0);


   /** destructor*/
   ~GuiLogin();

/** set hobit object*/
  void setHoBIT(HoBIT* hobit){
   _hobit = hobit;
  }

  /**
  *function for refreshing
  */
  virtual void refresh();


public slots:

  /**
  *slot for the login
  */
  virtual void slotLogin();

  /**
  *slot for the closing
  */
  virtual void slotClose();

  /**
  *slot changing the description of the account
  */
  virtual void slotShowDescription();

  /** Shows the edit button, if the user starts typing text in description edit field.
  */
  void slotShowEditButton();

  /** Sets the description of the account to text in lineEditDescription
  */
  void slotNewDescription();

private:

  HoBIT* _hobit;
  GuiMain* _guimain;

};

#endif
