/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Do Nov  4 11:52:24 CET 2004
    copyright            : (C) 2004 by Marcel Mulch, Walter Roth
    email                : marcel@mulch-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qapplication.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qstring.h>
#include <qtextcodec.h>
#include <qtranslator.h>
#include <qdir.h>
#include <qmessagebox.h>


//Styles
//#include <qplatinumstyle.h>
//#include <qwindowsstyle.h>
//#include <qmotifplusstyle.h>
#include <qstylefactory.h>
#include "guimain.h"
#include "guiloginpassword.h"
#include "guifindmedium.h"


 int main(int argc, char *argv[])
{
  QApplication app(argc, argv);
  qDebug("Application constructed.");
  setMP_DIR(app.applicationFilePath());
  if(USE_LIVE_CD_FEATURES){
    qDebug("USE_LIVE_CD_FEATURES: true");
      // starting chipcard daemon
      // system("sudo run_chipcard2 &");
    }
  else qDebug("USE_LIVE_CD_FEATURES: false");

  app.setFont(calculateScreenFont());//application wide font setting for all widgets  ;

  // Inintialize the translation engines
  // translation engine for Qt
  QTranslator qtTranslator( 0 );
  QString qmFileName = QM_FILE_NAME("qt_");
  if(qmFileName.isEmpty())
    qDebug("Will use the untranslated source code strings for Qt.");
  else{
    qDebug("Loading Qt translations from file: %s", qmFileName.latin1());
    qtTranslator.load( qmFileName );
  }
  qtTranslator.load(qmFileName);
  app.installTranslator( &qtTranslator );

  // translation engine for application strings
  QTranslator appTranslator( 0 );
  qmFileName = QM_FILE_NAME("moneypenny_");
  if(qmFileName.isEmpty())
    qDebug("Will use the untranslated source code strings for MoneyPenny.");
  else{
    qDebug("Loading MoneyPenny translations from file: %s", qmFileName.latin1());
    appTranslator.load( qmFileName );
  }
  app.installTranslator( &appTranslator );


 // Create some styles for choice
  //QStyle *style0=QStyleFactory::create("windows");
  //QStyle *style0=QStyleFactory::create("motif");
  QStyle *style0=QStyleFactory::create("platinum");
  if(style0)
    app.setStyle(style0); // style will be deleted by app on shutdown


   // create Main Gui
  GuiMain *guiMain = new GuiMain();
  qDebug("Main widget constructed.");
  app.setMainWidget(guiMain);

    //Show the splash
  guiMain->showSplashScreen();

  guiMain->buildMainApplication(); // Build the main application. This may take some time.
  qDebug("guiMain child widgets constructed.");

  ExitCode exitcode = EXITCODE_RUN_BANK_LOOP; //run bank loop
   while (exitcode == EXITCODE_RUN_BANK_LOOP || exitcode == EXITCODE_RESTART_SESSION){
      guiMain->showSplashScreen();
      if(guiMain->findMedium()){
       guiMain->login();

       //hide the splash screen
       guiMain->hideSplashScreen();

       //Select size of the window here
       //guiMain->show();  //use default window size
       //guiMain->showFullScreen(); //use the full screen, this will block the system tray!
        guiMain->showMaximized(); //use full screen, but do not cover system tray
        app.processEvents();
        if( guiMain->loadEnvironment()) //load decrypted data
          guiMain->slotAccountLogin();
        else exit (3);

       exitcode = (ExitCode)app.exec();
       qDebug("Event loop terminated");
     }
     else exitcode = EXITCODE_FAILURE; //no useable medium
  }
  delete guiMain; //deletes all child widgets
  return exitcode;

  //exit codes:
   // 0: Everything was ok
   // 1: Wrong login password
   // 2: No write access to medium
   // 3: Loading environment failed
   // 4: Installation error
   // 5: No automatic shutdown, call to "wait $moneypenny_pid" in script /etc/X11/xsession.d/45xsession will return 5 = nonzero
   // 6: Change bank. Shut down and restart GuiMain
}


